;; for report with time step
(defvar bzg-step-time-report-time nil)

(defun bzg-step-time-report-initialize (project)
  "Insert a 1st-level project at point."
  (interactive "sProject name: ")
  (insert "* " project)
  (org-insert-property-drawer)
  (org-entry-put (point) "COLUMNS" "%25ITEM %5Elapsed_time(Elapsed Time){:}")
  (next-line 2)
  (setq bzg-step-time-report-time (current-time)))

(defun bzg-step-time-report-add-step (&optional step)
  "Update elapsed time for previous step and insert the next one."
  (interactive "P")
  (let ((elapsed-time
	 (format-time-string 
	  "%H:%M" (time-since bzg-step-time-report-time) t))
	(step-name (when step (read-from-minibuffer "Step name: "))))
    (org-entry-put (point) "Elapsed_time" elapsed-time)
    (insert "** " (or step-name "Step"))
    (org-insert-property-drawer)
    (org-entry-put (point) "Elapsed_time" nil)
    (next-line 2)
    (setq bzg-step-time-report-time (current-time))))

(defun bzg-step-time-report-finish ()
  "Update elapsed time for previous step."
  (interactive)
  (let ((elapsed-time
	 (format-time-string 
	  "%H:%M" (time-since bzg-step-time-report-time) t)))
    (org-entry-put (point) "Elapsed_time" elapsed-time)))
